/* ============================================================================
 * AMES Wholesale Power Market Test Bed (Java): A Free Open-Source Test-Bed  
 *         for the Agent-based Modeling of Electricity Systems 
 * ============================================================================
 *
 * (C) Copyright 2008, by Hongyan Li, Junjie Sun, and Leigh Tesfatsion
 *
 *    Homepage: http://www.econ.iastate.edu/tesfatsi/AMESMarketHome.htm
 *
 * LICENSING TERMS
 * The AMES Market Package is licensed by the copyright holders (Junjie Sun, 
 * Hongyan Li, and Leigh Tesfatsion) as free open-source software under the       
 * terms of the GNU General Public License (GPL). Anyone who is interested is 
 * allowed to view, modify, and/or improve upon the code used to produce this 
 * package, but any software generated using all or part of this code must be 
 * released as free open-source software in turn. The GNU GPL can be viewed in 
 * its entirety as in the following site: http://www.gnu.org/licenses/gpl.html
 */

/*
 * PowerGridConfigure1.java
 *
 * Created on June 5, 2007, 4:41 PM
 */

package AMESGUIFrame;


import javax.swing.JOptionPane;

public class PowerGridConfigure1 extends javax.swing.JFrame {
    
    /** Creates new form PowerGridConfigure1 
     * @param frame 
     */
    public PowerGridConfigure1(AMESFrame frame) {
        mainFrame = frame;
        setTitle("Step 1: Input global parameters");
        initComponents();
    }
    
    public void SetInitParameters(int iNode, int iBranch, int ITransformer, int iGen, int iLSE, double V, double P){
   
        iTotalNodeNumber=iNode;
        iTotalBranchNumber=iBranch;
        iTotalTransformerNumber=ITransformer;
        iTotalGenNumber=iGen;
        iTotalLSENumber=iLSE;
        VBase=V;
        PowerBase=P;
       
        GridNodeTextField.setText(String.valueOf(iTotalNodeNumber));   
        GridLineTextField.setText(String.valueOf(iTotalBranchNumber));   
        GeneratorTextField.setText(String.valueOf(iTotalGenNumber));   
        LSETextField.setText(String.valueOf(iTotalLSENumber));   
        
        PowerBaseTextField.setText(String.valueOf(PowerBase));   
        VBaseTextField.setText(String.valueOf(VBase));   
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        GridNodeTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        GridLineTextField = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        GeneratorTextField = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        LSETextField = new javax.swing.JTextField();
        CancelButton = new javax.swing.JButton();
        NextButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        VBaseTextField = new javax.swing.JTextField();
        PowerBaseTextField = new javax.swing.JTextField();

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel1.setFont(new java.awt.Font("Arial", 0, 12));

        jLabel1.setFont(new java.awt.Font("Arial", 1, 12)); // NOI18N
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText(" Input total number of");
        jLabel1.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        jLabel2.setFont(new java.awt.Font("Arial", 0, 12)); // NOI18N
        jLabel2.setText("Grid Buses");
        jLabel2.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        GridNodeTextField.setFont(new java.awt.Font("Arial", 0, 12)); // NOI18N
        GridNodeTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        GridNodeTextField.setText("3");
        GridNodeTextField.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        jLabel3.setFont(new java.awt.Font("Arial", 0, 12)); // NOI18N
        jLabel3.setText("Grid Branches");
        jLabel3.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        GridLineTextField.setFont(new java.awt.Font("Arial", 0, 12)); // NOI18N
        GridLineTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        GridLineTextField.setText("3");
        GridLineTextField.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        jLabel5.setFont(new java.awt.Font("Arial", 0, 12)); // NOI18N
        jLabel5.setText("GenCos");
        jLabel5.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        GeneratorTextField.setFont(new java.awt.Font("Arial", 0, 12)); // NOI18N
        GeneratorTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        GeneratorTextField.setText("3");
        GeneratorTextField.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        jLabel6.setFont(new java.awt.Font("Arial", 0, 12)); // NOI18N
        jLabel6.setText("LSEs");
        jLabel6.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        LSETextField.setFont(new java.awt.Font("Arial", 0, 12)); // NOI18N
        LSETextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        LSETextField.setText("3");
        LSETextField.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(46, 46, 46)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, 95, Short.MAX_VALUE)
                            .addComponent(jLabel5, javax.swing.GroupLayout.DEFAULT_SIZE, 95, Short.MAX_VALUE)
                            .addComponent(jLabel6, javax.swing.GroupLayout.DEFAULT_SIZE, 95, Short.MAX_VALUE)
                            .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGap(32, 32, 32)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(GridNodeTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(GeneratorTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(GridLineTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(LSETextField, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(43, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(6, 6, 6)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel5)
                        .addGap(6, 6, 6)
                        .addComponent(jLabel6))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(GridNodeTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(GridLineTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(GeneratorTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(6, 6, 6)
                        .addComponent(LSETextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        CancelButton.setFont(new java.awt.Font("Arial", 0, 12)); // NOI18N
        CancelButton.setText("Cancel");
        CancelButton.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
        CancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CancelButtonActionPerformed(evt);
            }
        });

        NextButton.setFont(new java.awt.Font("Arial", 0, 12)); // NOI18N
        NextButton.setText("Next >>");
        NextButton.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
        NextButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                NextButtonActionPerformed(evt);
            }
        });

        jPanel2.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabel4.setFont(new java.awt.Font("Arial", 1, 12)); // NOI18N
        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel4.setText("Set base values for voltage and apparent power");
        jLabel4.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        jLabel7.setFont(new java.awt.Font("Arial", 0, 12)); // NOI18N
        jLabel7.setText("Voltage Base");
        jLabel7.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        jLabel8.setFont(new java.awt.Font("Arial", 0, 12)); // NOI18N
        jLabel8.setText("Apparent Power Base");
        jLabel8.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        VBaseTextField.setFont(new java.awt.Font("Arial", 0, 12)); // NOI18N
        VBaseTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        VBaseTextField.setText("10");
        VBaseTextField.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
        VBaseTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                VBaseTextFieldActionPerformed(evt);
            }
        });

        PowerBaseTextField.setFont(new java.awt.Font("Arial", 0, 12)); // NOI18N
        PowerBaseTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        PowerBaseTextField.setText("100");
        PowerBaseTextField.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
        PowerBaseTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                PowerBaseTextFieldActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jLabel8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel7, javax.swing.GroupLayout.DEFAULT_SIZE, 138, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 40, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(PowerBaseTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(VBaseTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(18, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap(18, Short.MAX_VALUE)
                .addComponent(jLabel4)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel4)
                .addGap(17, 17, 17)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel7)
                    .addComponent(VBaseTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(PowerBaseTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel8))
                .addContainerGap(29, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(111, 111, 111)
                        .addComponent(CancelButton, javax.swing.GroupLayout.PREFERRED_SIZE, 68, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(49, 49, 49)
                        .addComponent(NextButton, javax.swing.GroupLayout.PREFERRED_SIZE, 68, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(CancelButton)
                    .addComponent(NextButton))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void NextButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_NextButtonActionPerformed
        PowerGridConfigure2 config2 = mainFrame.getConfig2();
        
        if(mainFrame.isNewCase()) {
            String strMessage="";

            strMessage=DataVerify();
            if(!strMessage.isEmpty()){
                JOptionPane.showMessageDialog(this, strMessage, "Case Data Verify Message", JOptionPane.ERROR_MESSAGE);
                return;
            }

            mainFrame.setNewCaseInitialData(iTotalNodeNumber, iTotalBranchNumber, iTotalGenNumber, iTotalLSENumber, VBase, PowerBase);
        }
        
        this.setVisible(false);
        mainFrame.activeConfig2();
}//GEN-LAST:event_NextButtonActionPerformed

public void saveData(){
    mainFrame.setVBase(VBase);
    mainFrame.setPBase(PowerBase);
}

public String DataVerify(){
        String strMessage="";

        String strTemp =GridNodeTextField.getText();
        int iTemp;
            
        String message="The total grid bus number should bigger than 2!";
        try {
            iTemp=Integer.parseInt(strTemp);
          
            if(iTemp<3) {
                strMessage+=message;
            }
            else
               iTotalNodeNumber=iTemp;
        }
        catch (NumberFormatException e) {
            JOptionPane.showMessageDialog(this, message, "Error Message", JOptionPane.ERROR_MESSAGE); 
            return message;
        }
        
        strTemp =GridLineTextField.getText();
        message="The total grid branch number should bigger than 2!";
        try {
            iTemp=Integer.parseInt(strTemp);
          
            if(iTemp<3) {
                strMessage+=message;;
            }
            else
               iTotalBranchNumber=iTemp;
        }
        catch (NumberFormatException e) {
            JOptionPane.showMessageDialog(this, message, "Error Message", JOptionPane.ERROR_MESSAGE); 
            return message;
        }

        strTemp =GeneratorTextField.getText();
        message="The total generator number should bigger than or equal to 1!";
        try {
            iTemp=Integer.parseInt(strTemp);
          
            if(iTemp<1) {
                strMessage+=message;;
            }
            else
               iTotalGenNumber=iTemp;
        }
        catch (NumberFormatException e) {
            JOptionPane.showMessageDialog(this, message, "Error Message", JOptionPane.ERROR_MESSAGE); 
            return message;
        }

        strTemp =LSETextField.getText();
        message="The total LSE number should bigger than or equal to 1!";
        try {
            iTemp=Integer.parseInt(strTemp);
          
            if(iTemp<1) {
                strMessage+=message;;
            }
            else
               iTotalLSENumber=iTemp;
        }
        catch (NumberFormatException e) {
            JOptionPane.showMessageDialog(this, message, "Error Message", JOptionPane.ERROR_MESSAGE); 
            return message;
        }

        strTemp =VBaseTextField.getText();
        message="The voltage base value should bigger than 0!";
        try {
            double dTemp=Double.parseDouble(strTemp);
          
            if(dTemp<0) {
                strMessage+=message;;
            }
            else
               VBase=dTemp;
        }
        catch (NumberFormatException e) {
            JOptionPane.showMessageDialog(this, message, "Error Message", JOptionPane.ERROR_MESSAGE); 
            return message;
        }

        strTemp =PowerBaseTextField.getText();
        message="The apperant power base value should bigger than 0!";
        try {
            double dTemp=Double.parseDouble(strTemp);
          
            if(dTemp<0) {
                strMessage+=message;
            }
            else
               PowerBase=dTemp;
        }
        catch (NumberFormatException e) {
            JOptionPane.showMessageDialog(this, message, "Error Message", JOptionPane.ERROR_MESSAGE); 
            return message;
        }

        return strMessage;
    }
    
private void CancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CancelButtonActionPerformed
    this.setVisible(false);
}//GEN-LAST:event_CancelButtonActionPerformed

private void VBaseTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_VBaseTextFieldActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_VBaseTextFieldActionPerformed

private void PowerBaseTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_PowerBaseTextFieldActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_PowerBaseTextFieldActionPerformed
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton CancelButton;
    private javax.swing.JTextField GeneratorTextField;
    private javax.swing.JTextField GridLineTextField;
    private javax.swing.JTextField GridNodeTextField;
    private javax.swing.JTextField LSETextField;
    private javax.swing.JButton NextButton;
    private javax.swing.JTextField PowerBaseTextField;
    private javax.swing.JTextField VBaseTextField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    // End of variables declaration//GEN-END:variables
    public int iTotalNodeNumber;
    public int iTotalBranchNumber;
    public int iTotalTransformerNumber;
    public int iTotalGenNumber;
    public int iTotalLSENumber;
    
    public double VBase;
    public double PowerBase;
        
    private AMESFrame mainFrame;
    
}
