/*
 * Created on Jun 18, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.iastate.jrelm.rl;


/**
 * Interface for a collection of parameters needed for JReLMLearners.
 * 
 * @author Charles Gieseler
 *
 */
public interface RLParameters  {
		
	/**
	 * Get the name of the algorithm these parameters are for.
	 * 
	 * @return String name of the algorithm.
	 */
	public abstract String getName();
	
	/**
	 * Get a the names of the parameters
	 * 
	 * @return Array of parameter names as String
	 */
	public abstract String[] getParameterNames();
	
	/**
	 * Checks to make sure the current values for all parameters are valid.
	 * 
	 * @return true if all parameter values are valid, false otherwise.
	 */
	public abstract boolean validateParameters();
	
}
